package com.virtual.plat.server.publiccloud.rest;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.virtual.common.AppException;
import com.virtual.common.FuncUtil;
import com.virtual.plat.client.rpc.RpcResult;
import com.virtual.plat.server.ServerUtils;
import com.virtual.plat.server.controller.entity.CpuAndMemory;
import com.virtual.plat.server.controller.entity.ResourcePoolPo;
import com.virtual.plat.server.controller.entity.RpNetPo;
import com.virtual.plat.server.controller.entity.RpStoragePo;
import com.virtual.plat.server.controller.entity.StoragePo;
import com.virtual.plat.server.entity.Cluster;
import com.virtual.plat.server.entity.Domain;
import com.virtual.plat.server.entity.Host;
import com.virtual.plat.server.entity.Hostpool;
import com.virtual.plat.server.entity.PublicCloud;
import com.virtual.plat.server.entity.RpStorage;
import com.virtual.plat.server.publiccloud.rest.BaseCloud;
import com.virtual.plat.server.publiccloud.rest.Cloud;
import com.virtual.plat.server.rs.entity.RsRate;
import com.virtual.plat.server.rs.storage.entity.RsStorageVolume;
import com.virtual.plat.server.vm.vmware.HypervisorException;
import com.virtual.plat.server.vm.vmware.VMwareConnection;
import com.virtual.plat.server.vm.vmware.VMwareConnectionManager;
import com.virtual.plat.server.vmware.VMwareUtils;
import com.virtual.plat.server.vmware.entity.VmwareDisk;
import com.virtual.plat.server.vmware.entity.VmwarePerformance;
import com.vmware.vim25.ComputeResourceSummary;
import com.vmware.vim25.DatastoreSummary;
import com.vmware.vim25.HostListSummary;
import com.vmware.vim25.VirtualDevice;
import com.vmware.vim25.VirtualDisk;
import com.vmware.vim25.VirtualMachineConfigSummary;
import com.vmware.vim25.VirtualMachineSummary;
import com.vmware.vim25.mo.ClusterComputeResource;
import com.vmware.vim25.mo.Datacenter;
import com.vmware.vim25.mo.Datastore;
import com.vmware.vim25.mo.DistributedVirtualPortgroup;
import com.vmware.vim25.mo.HostSystem;
import com.vmware.vim25.mo.Network;
import com.vmware.vim25.mo.VirtualMachine;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import java.util.Map.Entry;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class VmwareCloud extends Cloud {

   private static Log a = LogFactory.getLog(BaseCloud.class);
   private VMwareConnectionManager b = null;


   public VmwareCloud(VMwareConnectionManager var1, PublicCloud var2) {
      super(var2);
      this.b = var1;
   }

   private List a(boolean var1) {
      Object var2 = Lists.newArrayList();
      VMwareConnection var3 = null;

      try {
         VirtualMachine[] var4;
         if((var4 = (var3 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryVM(var1)) == null) {
            Object var29 = var2;
            return (List)var29;
         } else {
            VMwareConnection var7 = var3;
            HashMap var8 = Maps.newHashMap();
            HostSystem[] var9;
            int var10 = (var9 = var3.queryHost()).length;

            int var11;
            String var12;
            VirtualMachine[] var13;
            int var14;
            int var15;
            VirtualMachine var16;
            for(var11 = 0; var11 < var10; ++var11) {
               var12 = var9[var11].getMOR().val;
               if(!ArrayUtils.isEmpty(var13 = var7.queryVMByHost(var12))) {
                  var14 = (var13 = var13).length;

                  for(var15 = 0; var15 < var14; ++var15) {
                     var16 = var13[var15];
                     var8.put(var16.getMOR().val, var12);
                  }
               }
            }

            HashMap var5 = var8;
            var7 = var3;
            var8 = Maps.newHashMap();
            ClusterComputeResource[] var32;
            var10 = (var32 = var3.queryCluster()).length;

            for(var11 = 0; var11 < var10; ++var11) {
               var12 = var32[var11].getMOR().val;
               if(!ArrayUtils.isEmpty(var13 = var7.queryVMByCluster(var12))) {
                  var14 = (var13 = var13).length;

                  for(var15 = 0; var15 < var14; ++var15) {
                     var16 = var13[var15];
                     var8.put(var16.getMOR().val, var12);
                  }
               }
            }

            HashMap var6 = var8;
            var7 = var3;
            var8 = Maps.newHashMap();
            Datacenter[] var33;
            var10 = (var33 = var3.queryDatacenter()).length;

            for(var11 = 0; var11 < var10; ++var11) {
               var12 = var33[var11].getMOR().val;
               if(!ArrayUtils.isEmpty(var13 = var7.queryVMByDC(var12))) {
                  var14 = (var13 = var13).length;

                  for(var15 = 0; var15 < var14; ++var15) {
                     var16 = var13[var15];
                     var8.put(var16.getMOR().val, var12);
                  }
               }
            }

            HashMap var30 = var8;
            int var31 = (var4 = var4).length;

            for(int var34 = 0; var34 < var31; ++var34) {
               VirtualMachine var35 = var4[var34];
               Domain var36;
               (var36 = new Domain()).setPublicCloudId(this.cloud.getId());
               var36.setCloudType(Integer.valueOf(3));
               var12 = var35.getMOR().getVal();
               var36.setUniqueKey(var12);
               Long var39 = Long.valueOf(Long.parseLong(var12.substring(var12.indexOf("vm-") + 3, var12.length())));
               var36.setForeignId(var39);
               var36.setHostKey((String)var5.get(var12));
               var36.setClusterKey((String)var6.get(var12));
               var36.setHpKey((String)var30.get(var12));
               VirtualMachineSummary var37 = var35.getSummary();
               var36.setStatus(VMwareUtils.getVmStatus(var37));
               var36.setTitle(var35.getName());
               var36.setDomainName(var35.getName());
               var36.setEnable(Integer.valueOf(var1?2:1));
               VirtualMachineConfigSummary var38 = var37.getConfig();
               var36.setDescription(var38.getAnnotation());
               var36.setUuid(var38.getUuid() == null?"":var38.getUuid());
               var36.setCpu(Integer.valueOf(var38.getNumCpu() == null?0:var38.getNumCpu().intValue()));
               var36.setMemory(Long.valueOf(var38.getMemorySizeMB() == null?0L:(long)var38.getMemorySizeMB().intValue()));
               var36.setStorageCapacity(Long.valueOf((new Double("" + VMwareUtils.getVmDiskCapacity(var35))).longValue()));
               var36.setOsVersion(var38.getGuestFullName());
               ((List)var2).add(var36);
            }

            return (List)var2;
         }
      } catch (HypervisorException var25) {
         a.error((Object)null, var25);
         throw new AppException(11, var25);
      } catch (AppException var26) {
         a.error((Object)null, var26);
         throw var26;
      } catch (Exception var27) {
         a.error((Object)null, var27);
         throw new AppException(11, var27);
      } finally {
         if(var3 != null) {
            try {
               this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var3);
            } catch (Exception var24) {
               var2 = var24;
               a.error(var24);
            }
         }

      }
   }

   private static Map a(VMwareConnection var0) {
      HashMap var1 = Maps.newHashMap();
      HostSystem[] var2;
      int var3 = (var2 = var0.queryHost()).length;

      for(int var4 = 0; var4 < var3; ++var4) {
         String var5 = var2[var4].getMOR().val;
         VirtualMachine[] var6;
         if(!ArrayUtils.isEmpty(var6 = var0.queryVMByHost(var5))) {
            int var7 = (var6 = var6).length;

            for(int var8 = 0; var8 < var7; ++var8) {
               VirtualMachine var9 = var6[var8];
               var1.put(var9.getMOR().val, var5);
            }
         }
      }

      return var1;
   }

   private static Map b(VMwareConnection var0) {
      HashMap var1 = Maps.newHashMap();
      ClusterComputeResource[] var2;
      int var3 = (var2 = var0.queryCluster()).length;

      for(int var4 = 0; var4 < var3; ++var4) {
         String var5 = var2[var4].getMOR().val;
         VirtualMachine[] var6;
         if(!ArrayUtils.isEmpty(var6 = var0.queryVMByCluster(var5))) {
            int var7 = (var6 = var6).length;

            for(int var8 = 0; var8 < var7; ++var8) {
               VirtualMachine var9 = var6[var8];
               var1.put(var9.getMOR().val, var5);
            }
         }
      }

      return var1;
   }

   private static Map c(VMwareConnection var0) {
      HashMap var1 = Maps.newHashMap();
      Datacenter[] var2;
      int var3 = (var2 = var0.queryDatacenter()).length;

      for(int var4 = 0; var4 < var3; ++var4) {
         String var5 = var2[var4].getMOR().val;
         VirtualMachine[] var6;
         if(!ArrayUtils.isEmpty(var6 = var0.queryVMByDC(var5))) {
            int var7 = (var6 = var6).length;

            for(int var8 = 0; var8 < var7; ++var8) {
               VirtualMachine var9 = var6[var8];
               var1.put(var9.getMOR().val, var5);
            }
         }
      }

      return var1;
   }

   private static Map d(VMwareConnection var0) {
      HashMap var1 = Maps.newHashMap();
      ClusterComputeResource[] var2;
      int var3 = (var2 = var0.queryCluster()).length;

      for(int var4 = 0; var4 < var3; ++var4) {
         String var5 = var2[var4].getMOR().val;
         HostSystem[] var6;
         if(!ArrayUtils.isEmpty(var6 = var0.queryClusterHost(var5))) {
            int var7 = (var6 = var6).length;

            for(int var8 = 0; var8 < var7; ++var8) {
               HostSystem var9 = var6[var8];
               var1.put(var9.getMOR().val, var5);
            }
         }
      }

      return var1;
   }

   private static Map e(VMwareConnection var0) {
      HashMap var1 = Maps.newHashMap();
      Datacenter[] var2;
      int var3 = (var2 = var0.queryDatacenter()).length;

      for(int var4 = 0; var4 < var3; ++var4) {
         String var5 = var2[var4].getMOR().val;
         HostSystem[] var6;
         if(!ArrayUtils.isEmpty(var6 = var0.queryDcHost(var5))) {
            int var7 = (var6 = var6).length;

            for(int var8 = 0; var8 < var7; ++var8) {
               HostSystem var9 = var6[var8];
               var1.put(var9.getMOR().val, var5);
            }
         }
      }

      return var1;
   }

   private static Map f(VMwareConnection var0) {
      HashMap var1 = Maps.newHashMap();
      Datacenter[] var2;
      int var3 = (var2 = var0.queryDatacenter()).length;

      for(int var4 = 0; var4 < var3; ++var4) {
         String var5 = var2[var4].getMOR().val;
         ClusterComputeResource[] var6;
         if(!ArrayUtils.isEmpty(var6 = var0.queryCluster(var5))) {
            int var7 = (var6 = var6).length;

            for(int var8 = 0; var8 < var7; ++var8) {
               ClusterComputeResource var9 = var6[var8];
               var1.put(var9.getMOR().val, var5);
            }
         }
      }

      return var1;
   }

   public static double getVmDiskCapacity(VirtualMachine var0) {
      if(var0 == null) {
         return 0.0D;
      } else {
         double var1 = 0.0D;
         VirtualDevice[] var7;
         if((var7 = var0.getConfig().getHardware().getDevice()) != null) {
            int var3 = (var7 = var7).length;

            for(int var4 = 0; var4 < var3; ++var4) {
               VirtualDevice var5;
               if((var5 = var7[var4]) instanceof VirtualDisk) {
                  VirtualDisk var6 = (VirtualDisk)var5;
                  var1 += (double)var6.getCapacityInKB();
               }
            }
         }

         return var1 /= 1024.0D;
      }
   }

   public List queryVms(byte var1) {
      ArrayList var2 = Lists.newArrayList();
      if((var1 & 10) != 0) {
         var2.addAll(this.a(false));
      }

      if((var1 & 1) != 0) {
         var2.addAll(this.a(true));
      }

      return var2;
   }

   public void testConnection() {
      VMwareConnection var1;
      try {
         this.b.closeConnection(this.cloud.getConnectUri(), this.cloud.getUserName());
         this.b.setConnectionConfig(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword());
         var1 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword());
      } catch (Throwable var3) {
         throw var3;
      }

      if(var1 != null) {
         this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var1);
      }
   }

   public boolean checkTemplate(String var1) {
      VMwareConnection var2 = null;
      String var3 = null;
      String var4 = null;

      try {
         var3 = this.cloud.getConnectUri();
         var4 = this.cloud.getUserName();
         if((var2 = this.b.getConnection(var3, var4, this.cloud.getPassword())).queryVMByKey(var1) == null) {
            return false;
         }
      } catch (Exception var7) {
         a.error((Object)null, var7);
         return false;
      } finally {
         if(var2 != null) {
            this.b.releaseConnection(var3, var4, var2);
         }

      }

      return true;
   }

   public RpcResult operatorDomain(String var1, String var2) {
      return null;
   }

   public Map getResourceOverview(String var1) {
      return null;
   }

   public String getDomainStatus(String var1) {
      VMwareConnection var2 = null;

      try {
         String var3 = VMwareUtils.getVmStatus((var2 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryVMByKey(var1));
         return var3;
      } catch (Exception var6) {
         a.error("get vmware domain status error, vCenterId is " + this.cloud.getId() + ", domainId is " + var1, var6);
      } finally {
         if(var2 != null) {
            this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var2);
         }

      }

      return "unknown";
   }

   public List queryHostpools() {
      ArrayList var1 = Lists.newArrayList();
      VMwareConnection var2 = null;

      ArrayList var21;
      try {
         Datacenter[] var3;
         if((var3 = (var2 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryDatacenter()) != null) {
            int var4 = (var3 = var3).length;

            for(int var5 = 0; var5 < var4; ++var5) {
               Datacenter var6 = var3[var5];
               Hostpool var7;
               (var7 = new Hostpool()).setPublicCloudId(this.cloud.getId());
               String var8 = var6.getMOR().val;
               var7.setUniqueKey(var8);
               var7.setName(var6.getName());
               var1.add(var7);
            }

            return var1;
         }

         var21 = var1;
      } catch (HypervisorException var17) {
         a.error((Object)null, var17);
         throw new AppException(11, var17);
      } catch (AppException var18) {
         a.error((Object)null, var18);
         throw var18;
      } catch (Exception var19) {
         a.error((Object)null, var19);
         throw new AppException(11, var19);
      } finally {
         if(var2 != null) {
            try {
               this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var2);
            } catch (Exception var16) {
               a.error(var16);
            }
         }

      }

      return var21;
   }

   public List queryClusters() {
      ArrayList var1 = Lists.newArrayList();
      VMwareConnection var2 = null;

      ArrayList var4;
      try {
         ClusterComputeResource[] var3;
         if((var3 = (var2 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryCluster()) != null) {
            VMwareConnection var26 = var2;
            HashMap var5 = Maps.newHashMap();
            Datacenter[] var6;
            int var7 = (var6 = var2.queryDatacenter()).length;

            String var9;
            for(int var8 = 0; var8 < var7; ++var8) {
               var9 = var6[var8].getMOR().val;
               ClusterComputeResource[] var10;
               if(!ArrayUtils.isEmpty(var10 = var26.queryCluster(var9))) {
                  int var11 = (var10 = var10).length;

                  for(int var12 = 0; var12 < var11; ++var12) {
                     ClusterComputeResource var13 = var10[var12];
                     var5.put(var13.getMOR().val, var9);
                  }
               }
            }

            HashMap var27 = var5;
            int var28 = (var3 = var3).length;

            for(int var29 = 0; var29 < var28; ++var29) {
               ClusterComputeResource var30 = var3[var29];
               Cluster var31;
               (var31 = new Cluster()).setPublicCloudId(this.cloud.getId());
               var9 = var30.getMOR().val;
               var31.setUniqueKey(var9);
               var31.setName(var30.getName());
               var31.setHpKey((String)var27.get(var9));
               var1.add(var31);
            }

            return var1;
         }

         var4 = var1;
      } catch (HypervisorException var22) {
         a.error((Object)null, var22);
         throw new AppException(11, var22);
      } catch (AppException var23) {
         a.error((Object)null, var23);
         throw var23;
      } catch (Exception var24) {
         a.error((Object)null, var24);
         throw new AppException(11, var24);
      } finally {
         if(var2 != null) {
            try {
               this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var2);
            } catch (Exception var21) {
               a.error(var21);
            }
         }

      }

      return var4;
   }

   public List queryHosts() {
      ArrayList var1 = Lists.newArrayList();
      VMwareConnection var2 = null;

      try {
         HostSystem[] var3;
         if((var3 = (var2 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryHost()) == null) {
            ArrayList var27 = var1;
            return var27;
         }

         VMwareConnection var5 = var2;
         HashMap var6 = Maps.newHashMap();
         ClusterComputeResource[] var7;
         int var8 = (var7 = var2.queryCluster()).length;

         int var9;
         String var10;
         HostSystem[] var11;
         int var12;
         int var13;
         HostSystem var14;
         for(var9 = 0; var9 < var8; ++var9) {
            var10 = var7[var9].getMOR().val;
            if(!ArrayUtils.isEmpty(var11 = var5.queryClusterHost(var10))) {
               var12 = (var11 = var11).length;

               for(var13 = 0; var13 < var12; ++var13) {
                  var14 = var11[var13];
                  var6.put(var14.getMOR().val, var10);
               }
            }
         }

         HashMap var4 = var6;
         var5 = var2;
         var6 = Maps.newHashMap();
         Datacenter[] var30;
         var8 = (var30 = var2.queryDatacenter()).length;

         for(var9 = 0; var9 < var8; ++var9) {
            var10 = var30[var9].getMOR().val;
            if(!ArrayUtils.isEmpty(var11 = var5.queryDcHost(var10))) {
               var12 = (var11 = var11).length;

               for(var13 = 0; var13 < var12; ++var13) {
                  var14 = var11[var13];
                  var6.put(var14.getMOR().val, var10);
               }
            }
         }

         HashMap var28 = var6;
         int var29 = (var3 = var3).length;

         for(int var31 = 0; var31 < var29; ++var31) {
            HostSystem var32 = var3[var31];
            Host var34;
            (var34 = new Host()).setPublicCloudId(this.cloud.getId());
            var10 = var32.getMOR().val;
            var34.setUniqueKey(var10);
            var34.setName(var32.getName());
            var34.setClusterKey((String)var4.get(var10));
            var34.setHpKey((String)var28.get(var10));
            HostListSummary var33 = var32.getSummary();
            var34.setStatus(Integer.valueOf(VMwareUtils.getHostStatus(var33)));
            var1.add(var34);
         }
      } catch (HypervisorException var23) {
         a.error((Object)null, var23);
         throw new AppException(11, var23);
      } catch (AppException var24) {
         a.error((Object)null, var24);
         throw var24;
      } catch (Exception var25) {
         a.error((Object)null, var25);
         throw new AppException(11, var25);
      } finally {
         if(var2 != null) {
            try {
               this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var2);
            } catch (Exception var22) {
               a.error(var22);
            }
         }

      }

      return var1;
   }

   public CpuAndMemory queryClusterCpuAndMemory(String var1) {
      VMwareConnection var2 = null;
      CpuAndMemory var3 = null;

      try {
         ClusterComputeResource var4;
         if((var4 = (var2 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryClusterBykey(var1)) != null) {
            var3 = new CpuAndMemory();
            ComputeResourceSummary var12;
            short var5 = (var12 = var4.getSummary()).getNumCpuThreads();
            var3.setCpu(var5);
            var3.setMemory(var12.getTotalMemory() / 1048576L);
            return var3;
         }
      } catch (HypervisorException var9) {
         a.error((Object)null, var9);
         throw var9;
      } catch (Exception var10) {
         a.error("get vmware cluster info error, vCenterId is " + this.cloud.getId() + ", cluster key is " + var1, var10);
         return var3;
      } finally {
         if(var2 != null) {
            this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var2);
         }

      }

      return null;
   }

   public List queryAllCloudClusterByHostpoolId(Long var1) {
      return null;
   }

   public List queryHostsByCondition(Long var1, Long var2) {
      return null;
   }

   public List queryAllHosts() {
      return null;
   }

   public List queryAllClusters() {
      return null;
   }

   public ResourcePoolPo queryClusterSummaryInfo(String var1) {
      return null;
   }

   public List queryStorageInCluster(String var1, Boolean var2) {
      VMwareConnection var22 = null;
      ArrayList var3 = new ArrayList();

      try {
         ClusterComputeResource var4;
         if((var4 = (var22 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryClusterBykey(var1)) == null) {
            return null;
         }

         Datastore[] var23;
         if((var23 = var4.getDatastores()) != null) {
            for(int var5 = 0; var5 < var23.length; ++var5) {
               try {
                  Datastore var6;
                  DatastoreSummary var7;
                  long var10 = (var7 = (var6 = var23[var5]).getSummary()).getFreeSpace();
                  long var12 = var7.getCapacity();
                  if(var7.isAccessible()) {
                     RpStoragePo var8;
                     (var8 = new RpStoragePo()).setName(var6.getMOR().getVal());
                     var8.setPath(var7.getUrl());
                     var8.setType(var7.getType());
                     var8.setStorageCapacity(Long.valueOf(var12));
                     var8.setAvalibaleCapacity(FuncUtil.getDoubleValue(Long.valueOf(var10)));
                     var3.add(var8);
                  }
               } catch (Exception var18) {
                  a.error("get datastore total error", var18);
               }
            }
         }
      } catch (HypervisorException var19) {
         a.error((Object)null, var19);
         throw var19;
      } catch (Exception var20) {
         a.error("get vmware cluster info error, vCenterId is " + this.cloud.getId() + ", cluster key is " + var1, var20);
         throw new AppException(11);
      } finally {
         if(var22 != null) {
            this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var22);
         }

      }

      return var3;
   }

   public List queryStorageRes(PublicCloud var1, String var2) {
      ArrayList var3 = new ArrayList();
      VMwareConnection var4 = null;

      try {
         var4 = this.b.getConnection(var1.getConnectUri(), var1.getUserName(), var1.getPassword());
         ClusterComputeResource var5;
         if((var5 = var4.queryClusterBykey(var2)) != null && var5.getDatastores() != null) {
            DecimalFormat var6 = new DecimalFormat("##.##");
            Datastore[] var7;
            int var8 = (var7 = var5.getDatastores()).length;

            for(int var9 = 0; var9 < var8; ++var9) {
               Datastore var10;
               DatastoreSummary var11;
               if((var11 = (var10 = var7[var9]).getSummary()).accessible) {
                  StoragePo var12 = new StoragePo();
                  double var14 = (double)var11.getFreeSpace() / 1048576.0D;
                  var12.setName(var10.getMOR().getVal());
                  var12.setClusterId(FuncUtil.getLongValue(var2.replace("domain-c", "")));
                  var12.setClusterName(var5.getName());
                  var12.setTitle(var10.getName());
                  var12.setType(var11.getType());
                  var12.setPath(var10.getInfo().url);
                  var12.setFreeSpace(FuncUtil.getDoubleValue(var6.format(var14)));
                  var12.setCapacity(FuncUtil.getDoubleValue(Long.valueOf(var11.getCapacity())));
                  var3.add(var12);
               }
            }
         }
      } catch (AppException var19) {
         ServerUtils.logAppException(a, var19);
         throw var19;
      } catch (Exception var20) {
         a.error(var20.getMessage(), var20);
      } finally {
         if(var4 != null) {
            this.b.releaseConnection(var1.getConnectUri(), var1.getUserName(), var4);
         }

      }

      return var3;
   }

   public double queryClusterCpuRate(String var1) {
      VMwareConnection var2 = null;
      Double var3 = Double.valueOf(0.0D);

      try {
         ClusterComputeResource var4;
         if((var4 = (var2 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryClusterBykey(var1)) != null) {
            long var5;
            if((var5 = var2.queryManagedEntityPerformance(var4, "cpu.usage.average")) > 0L) {
               var3 = Double.valueOf((double)var5 / 100.0D);
            }

            double var7 = var3.doubleValue();
            return var7;
         }
      } catch (HypervisorException var12) {
         a.error((Object)null, var12);
         throw var12;
      } catch (Exception var13) {
         a.error("get vmware cluster info error, vCenterId is " + this.cloud.getId() + ", cluster key is " + var1, var13);
         throw new AppException(11);
      } finally {
         if(var2 != null) {
            this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var2);
         }

      }

      return 0.0D;
   }

   public double queryClusterMemoryRate(String var1) {
      VMwareConnection var2 = null;
      Double var3 = Double.valueOf(0.0D);

      double var7;
      try {
         ClusterComputeResource var4;
         if((var4 = (var2 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryClusterBykey(var1)) == null) {
            return 0.0D;
         }

         long var5;
         if((var5 = var2.queryManagedEntityPerformance(var4, "mem.consumed.average")) > 0L) {
            long var8 = var4.getSummary().getTotalMemory() / 1024L;
            var3 = Double.valueOf((double)var5 * 100.0D / (double)var8);
         }

         var7 = var3.doubleValue();
      } catch (HypervisorException var13) {
         a.error((Object)null, var13);
         throw var13;
      } catch (Exception var14) {
         a.error("get vmware cluster info error, vCenterId is " + this.cloud.getId() + ", cluster key is " + var1, var14);
         throw new AppException(11);
      } finally {
         if(var2 != null) {
            this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var2);
         }

      }

      return var7;
   }

   public List queryProfile() {
      return null;
   }

   public List queryNet(String var1) {
      ArrayList var2 = new ArrayList();
      VMwareConnection var3 = null;

      try {
         Network[] var12;
         if((var12 = (var3 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryClusterBykey(var1).getNetworks()) != null) {
            int var4 = (var12 = var12).length;

            for(int var5 = 0; var5 < var4; ++var5) {
               Network var6 = var12[var5];
               RpNetPo var7 = new RpNetPo();
               if(var6 instanceof DistributedVirtualPortgroup) {
                  DistributedVirtualPortgroup var13 = (DistributedVirtualPortgroup)var6;
                  var7.setName(var13.getName());
                  var7.setVswitchKey(var13.getMOR().getVal());
               } else {
                  var7.setName(var6.getName());
                  var7.setVswitchKey(var6.getMOR().getVal());
               }

               var7.setMode(Integer.valueOf(0));
               var2.add(var7);
            }
         }
      } catch (Exception var10) {
         a.error((Object)null, var10);
      } finally {
         if(var3 != null) {
            this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var3);
         }

      }

      return var2;
   }

   public List queryVirtHostTop5Rate(String var1, String var2) {
      return null;
   }

   public List queryComputeResourceTrend(String var1, String var2) {
      VMwareConnection var3 = null;
      ArrayList var4 = new ArrayList();

      try {
         ClusterComputeResource var5;
         if((var5 = (var3 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryClusterBykey(var1)) == null) {
            throw new AppException(1101);
         }

         List var15;
         if((var15 = var3.queryClusterPerfTrend(var5, var2)) != null && !var15.isEmpty()) {
            Iterator var16 = var15.iterator();

            while(var16.hasNext()) {
               VmwarePerformance var17 = (VmwarePerformance)var16.next();
               RsRate var6;
               (var6 = new RsRate()).setTime(var17.getTime());
               var6.setRate(var17.getRate());
               var4.add(var6);
            }
         }
      } catch (HypervisorException var11) {
         a.error((Object)null, var11);
         throw var11;
      } catch (AppException var12) {
         a.error((Object)null, var12);
         throw var12;
      } catch (Exception var13) {
         a.error("vmware queryComputeResourceTrend " + this.cloud.getId() + ", cluster key is " + var1, var13);
         throw new AppException(11);
      } finally {
         if(var3 != null) {
            this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var3);
         }

      }

      return var4;
   }

   public StoragePo queryStorageBaseInfo(String var1) {
      VMwareConnection var2 = null;

      try {
         Datastore var8 = (var2 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryDatastoreByKey(var1);
         StoragePo var3 = new StoragePo();
         if(var8 != null) {
            var3.setFreeSpace(FuncUtil.getDoubleValue(Double.valueOf((double)var8.getSummary().getFreeSpace() / 1048576.0D)));
            var3.setCapacity(FuncUtil.getDoubleValue(Double.valueOf((double)var8.getSummary().getCapacity() / 1048576.0D)));
            var3.setType(var8.getSummary().getType());
            var3.setName(var8.getSummary().getName());
         }

         StoragePo var9 = var3;
         return var9;
      } catch (Exception var6) {
         a.error(var6.getMessage(), var6);
      } finally {
         if(var2 != null) {
            this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var2);
         }

      }

      return null;
   }

   public List queryVmStorageInfo(List var1, String var2, String var3) {
      Object var22 = new ArrayList();
      VMwareConnection var4 = null;

      try {
         HashMap var5 = new HashMap();
         VirtualMachine[] var6;
         int var7 = (var6 = (var4 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryVMByKey(var1)).length;

         for(int var8 = 0; var8 < var7; ++var8) {
            VirtualMachine var9 = var6[var8];
            Double var10 = Double.valueOf(0.0D);
            Iterator var11 = VMwareUtils.getVmDevices(var9).getDisks().iterator();

            while(var11.hasNext()) {
               VmwareDisk var12;
               String var13;
               if((var13 = (var12 = (VmwareDisk)var11.next()).getPath().split("]")[0]).substring(1, var13.length()).equals(var3)) {
                  var10 = Double.valueOf(var10.doubleValue() + (double)var12.getCapacityInKB().longValue() / 1048576.0D);
               }
            }

            if(var10.doubleValue() != 0.0D && var1.contains(var9.getMOR().getVal())) {
               RsStorageVolume var25;
               (var25 = new RsStorageVolume()).setDomainName(var9.getName());
               var5.put(var25, var10);
            }
         }

         if(!var5.isEmpty()) {
            ArrayList var23;
            Collections.sort(var23 = new ArrayList(var5.entrySet()), new Comparator() {

               // $FF: synthetic field
               private VmwareCloud a;

               private static int a(Entry var0, Entry var1) {
                  return ((Double)var1.getValue()).compareTo((Double)var0.getValue());
               }
               // $FF: synthetic method
               public final int compare(Object var1, Object var2) {
                  Entry var10000 = (Entry)var1;
                  Entry var4 = (Entry)var2;
                  Entry var3 = var10000;
                  return ((Double)var4.getValue()).compareTo((Double)var3.getValue());
               }
            });

            for(var7 = 0; var7 < (var23.size() < 5?var23.size():5); ++var7) {
               RsStorageVolume var24;
               (var24 = new RsStorageVolume()).setDomainName(((RsStorageVolume)((Entry)var23.get(var7)).getKey()).getDomainName());
               var24.setSize((Double)((Entry)var23.get(var7)).getValue());
               ((List)var22).add(var24);
            }
         }
      } catch (Exception var20) {
         a.error((Object)null, var20);
      } finally {
         if(var4 != null) {
            try {
               this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var4);
            } catch (Exception var19) {
               var22 = var19;
               a.error(var19);
            }
         }

      }

      return (List)var22;
   }

   public List queryStorageHistory(String var1) {
      return new ArrayList();
   }

   public Map queryOrgStorageInfo(List var1, String var2, String var3) {
      Object var21 = new TreeMap();
      VMwareConnection var4 = null;

      try {
         ArrayList var5 = new ArrayList();
         Iterator var6 = var1.iterator();

         while(var6.hasNext()) {
            Domain var7 = (Domain)var6.next();
            var5.add(var7.getUniqueKey());
         }

         VirtualMachine[] var24;
         int var22 = (var24 = (var4 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryVMByKey(var5)).length;

         for(int var23 = 0; var23 < var22; ++var23) {
            VirtualMachine var8 = var24[var23];
            Double var9 = Double.valueOf(0.0D);
            Iterator var10 = VMwareUtils.getVmDevices(var8).getDisks().iterator();

            while(var10.hasNext()) {
               VmwareDisk var11;
               String var12;
               if((var12 = (var11 = (VmwareDisk)var10.next()).getPath().split("]")[0]).substring(1, var12.length()).equals(var3)) {
                  var9 = Double.valueOf(var9.doubleValue() + (double)var11.getCapacityInKB().longValue() / 1048576.0D);
               }
            }

            if(var9.doubleValue() != 0.0D) {
               var10 = var1.iterator();

               while(var10.hasNext()) {
                  Domain var25;
                  if((var25 = (Domain)var10.next()).getUniqueKey().equals(var8.getMOR().getVal())) {
                     if(((Map)var21).containsKey(Long.valueOf(var25.getOrgId()))) {
                        ((Map)var21).put(Long.valueOf(var25.getOrgId()), Double.valueOf(var9.doubleValue() + ((Double)((Map)var21).get(Long.valueOf(var25.getOrgId()))).doubleValue()));
                     } else {
                        ((Map)var21).put(Long.valueOf(var25.getOrgId()), var9);
                     }
                  }
               }
            }
         }
      } catch (Exception var19) {
         a.error((Object)null, var19);
      } finally {
         if(var4 != null) {
            try {
               this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var4);
            } catch (Exception var18) {
               var21 = var18;
               a.error(var18);
            }
         }

      }

      return (Map)var21;
   }

   public List queryStorageList(List var1, Cluster var2) {
      ArrayList var3 = new ArrayList();
      VMwareConnection var4;
      ClusterComputeResource var13 = (var4 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryClusterBykey(var2.getUniqueKey());

      try {
         Iterator var12 = var1.iterator();

         while(var12.hasNext()) {
            RpStorage var5 = (RpStorage)var12.next();
            StoragePo var6;
            (var6 = new StoragePo()).setId(var5.getId());
            var6.setBackupFlag(var5.getBackupFlag());
            if(var13 == null) {
               var6.setFlag(false);
               var6.setPath(var5.getPath());
               var6.setName(var5.getName());
               var6.setTitle("");
               var6.setCapacity(Double.valueOf(0.0D));
               var3.add(var6);
            } else {
               Datastore var7;
               if((var7 = var4.queryDatastoreByKey(var5.getName())) == null) {
                  var6.setFlag(false);
                  var6.setName(var5.getName());
                  var6.setPath(var5.getPath());
                  var6.setTitle("");
                  var6.setCapacity(Double.valueOf(0.0D));
                  var3.add(var6);
               } else {
                  var6.setName(var7.getMOR().getVal());
                  var6.setTitle(var7.getName());
                  var6.setType(var7.getSummary().getType());
                  var6.setCapacity(Double.valueOf(FuncUtil.getDoubleValue(Long.valueOf(var7.getSummary().getFreeSpace())).doubleValue() / 1048576.0D));
                  var3.add(var6);
               }
            }
         }
      } catch (Exception var10) {
         a.error((Object)null, var10);
      } finally {
         if(var4 != null) {
            this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var4);
         }

      }

      return var3;
   }

   public void checkCluster(String var1) {
      if(var1 == null) {
         throw new AppException(17003);
      } else {
         VMwareConnection var2;
         ClusterComputeResource var3 = (var2 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryClusterBykey(var1);
         if(var2 != null) {
            this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var2);
         }

         if(var3 == null) {
            throw new AppException(17003);
         }
      }
   }

   public List queryIORwAndIOPSTrend(String var1, String var2, String var3) {
      return null;
   }

   public List queryOrgVmStorageInfo(List var1, List var2) {
      ArrayList var3 = new ArrayList();
      VMwareConnection var4 = null;

      try {
         ArrayList var5 = new ArrayList();
         Iterator var22 = var1.iterator();

         while(var22.hasNext()) {
            String var6 = (String)var22.next();
            var5.add(var6);
         }

         HashMap var23 = new HashMap();
         var2 = a(var4 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword()), var2);
         VirtualMachine[] var24;
         int var7 = (var24 = var4.queryVMByKey(var5)).length;

         for(int var8 = 0; var8 < var7; ++var8) {
            VirtualMachine var9 = var24[var8];
            Double var10 = Double.valueOf(0.0D);
            Iterator var11 = VMwareUtils.getVmDevices(var9).getDisks().iterator();

            while(var11.hasNext()) {
               VmwareDisk var12;
               String var13 = (var12 = (VmwareDisk)var11.next()).getPath().split("]")[0];
               if(var2.contains(var13.substring(1, var13.length()))) {
                  var10 = Double.valueOf(var10.doubleValue() + (double)var12.getCapacityInKB().longValue() / 1048576.0D);
               }
            }

            if(var10.doubleValue() != 0.0D && var5.contains(var9.getMOR().getVal())) {
               RsStorageVolume var27;
               (var27 = new RsStorageVolume()).setDomainName(var9.getName());
               var23.put(var27, var10);
            }
         }

         if(!var23.isEmpty()) {
            ArrayList var25;
            Collections.sort(var25 = new ArrayList(var23.entrySet()), new Comparator() {

               // $FF: synthetic field
               private VmwareCloud a;

               private static int a(Entry var0, Entry var1) {
                  return ((Double)var1.getValue()).compareTo((Double)var0.getValue());
               }
               // $FF: synthetic method
               public final int compare(Object var1, Object var2) {
                  Entry var10000 = (Entry)var1;
                  Entry var4 = (Entry)var2;
                  Entry var3 = var10000;
                  return ((Double)var4.getValue()).compareTo((Double)var3.getValue());
               }
            });

            for(var7 = 0; var7 < (var25.size() < 5?var25.size():5); ++var7) {
               RsStorageVolume var26;
               (var26 = new RsStorageVolume()).setDomainName(((RsStorageVolume)((Entry)var25.get(var7)).getKey()).getDomainName());
               var26.setSize((Double)((Entry)var25.get(var7)).getValue());
               var3.add(var26);
            }
         }
      } catch (Exception var20) {
         a.error((Object)null, var20);
      } finally {
         if(var4 != null) {
            try {
               this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var4);
            } catch (Exception var19) {
               a.error(var19);
            }
         }

      }

      return var3;
   }

   private static List a(VMwareConnection var0, List var1) {
      ArrayList var2 = new ArrayList();
      Iterator var4 = var1.iterator();

      while(var4.hasNext()) {
         String var3 = (String)var4.next();
         Datastore var5;
         if((var5 = var0.queryDatastoreByKey(var3)) != null) {
            var2.add(var5.getName());
         }
      }

      return var2;
   }

   public List queryStoragePerfTrend(String var1, String var2) {
      VMwareConnection var3 = null;

      ArrayList var4;
      try {
         Datastore var13 = (var3 = this.b.getConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), this.cloud.getPassword())).queryDatastoreByKey(var1);
         String var15 = "";
         if("used".equals(var2)) {
            var15 = "disk.used.latest";
         } else if("provisioned".equals(var2)) {
            var15 = "disk.provisioned.latest";
         }

         List var14 = var3.queryDatastorePerfTrend(var13, var15);
         return var14;
      } catch (Exception var11) {
         a.error((Object)null, var11);
         var4 = new ArrayList();
      } finally {
         if(var3 != null) {
            try {
               this.b.releaseConnection(this.cloud.getConnectUri(), this.cloud.getUserName(), var3);
            } catch (Exception var10) {
               a.error(var10);
            }
         }

      }

      return var4;
   }

}
